accounts/urls.py
from django.urls import path, include

from . import views

app_name = 'accounts'

urlpatterns = [
    path('signup', views.sign_up, name='sign_up'),
    path('profile', views.profile, name='profile'),
    path('profile/edit', views.profile_edit, name='profile_edit'),
]

blog/urls.py
from django.urls import path

from . import views
from .views import ArticleDetail, CategoryDetail

app_name = 'blog'

urlpatterns = [
    # Articles
    path('', views.article_list, name='article_list'),
    path("<slug:slug>", ArticleDetail.as_view(), name="article-detail"),

    # Categories
    path('list/', views.category_list, name='category_list'),
    path("<slug:slug>", CategoryDetail.as_view(), name="category-detail"),


]

project/urls.py
from django.contrib import admin
from django.urls import path, include

from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('accounts/', include('django.contrib.auth.urls')),
    path('accounts/', include('accounts.urls', namespace='accounts')),
    path('admin/', admin.site.urls),
    path('jobs/', include('jobs.urls', namespace='jobs')),
    path('contact', include('contact.urls', namespace='contact')),
    path('blog/', include('blog.urls', namespace='blog')),
    path('', include('home.urls', namespace='home')),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

accounts/models.py
from django.contrib.auth.models import User
from django.db import models
from django.db.models.signals import post_save
from django.dispatch import receiver
from django_countries.fields import CountryField


# Create your models here.


class Profile(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    profile_pic = models.ImageField(upload_to='profile_pics/')
    country = CountryField(blank_label='(select country)')

    def __str__(self):
        return str(self.user)


# Function to create new empty profile everytime
# a new user is created.
@receiver(post_save, sender=User)
def create_user_profile(sender, instance, created, **kwargs):
    if created:
        Profile.objects.create(user=instance)

accounts/forms.py
from urllib import request

from django import forms
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User

from accounts.models import Profile


class SignupForm(UserCreationForm):
    class Meta:
        model = User
        fields = ['username', 'email', 'password1', 'password2']


class UserForm(forms.ModelForm):
    class Meta:
        model = User
        fields = ['username', 'first_name', 'last_name', 'email']


class ProfileForm(forms.ModelForm):
    class Meta:
        model = Profile
        fields = ['user', 'country', 'profile_pic']

accounts/views.py
from django.contrib.auth import authenticate, login
from django.shortcuts import render, redirect
from django.template.context_processors import request
from django.urls import reverse

from .forms import SignupForm, UserForm, ProfileForm
from .models import Profile


# Create your views here.

def sign_up(request):
    # If method is post, save data and send request
    form = SignupForm(request.POST)
    if request.method == "POST":
        if form.is_valid():
            form.save()
            username = form.cleaned_data["username"]
            password = form.cleaned_data["password1"]
            user = authenticate(username=username, password=password)
            login(request, user)
            return redirect('/accounts/profile')

    else:  # just display form
        form = SignupForm()
    return render(request, 'registration/signup.html', {'form': form})


def profile(request):
    profile = Profile.objects.get(user=request.user)
    return render(request, 'accounts/profile.html', {'profile': profile})


def profile_edit(request):
    profile = Profile.objects.get(user=request.user)

    if request.method == 'POST':
        # 1 Passed Data of the two forms.
        userform = UserForm(request.POST, instance=request.user)
        # 1.1 Add request.FILES to read images from form.
        profileform = ProfileForm(request.POST, request.FILES, instance=profile)
        # 2 Check if the two forms are valid.
        if userform.is_valid() and profileform.is_valid():
            # 3 Save user form.
            userform.save()
            # 4 Stop profile form from being saved.
            myprofile = profileform.save(commit=False)
            # 5 Passed user data to my profile form
            myprofile.user = request.user
            # 6 Saved my profile form.
            myprofile.save()
            return redirect(reverse('accounts:profile'))
    else:
        userform = UserForm(instance=request.user)
        profileform = ProfileForm(instance=profile)

    context = {
        'userform': userform,
        'profileform': profileform,
    }

    return render(request, 'accounts/profile_edit.html', context)

accounts/templates/accounts/profile.html
{{% extends "accounts_base.html" %}
{% load bootstrap5 %}
{% block body %}



    <!-------------- HERO SECTION --------------->
    <div class="bradcam_area bradcam_bg_1" style="margin-top: -24px">
        <div class="container">
            <div class="row">
                <div class="col-xl-12">
                    <div class="bradcam_text">
                        <h3>Profile Dashboard</h3>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-------------- HERO SECTION --------------->

    <div class="job_details_area">
        <div class="container mb-5">
            <div class="row">
                <div class="col-lg-8 mx-auto mb-5 ">
                    <div class="job_sumary">
                        <div class="summery_header">
                            <h3>Job Summery</h3>
                        </div>
                        <div class="job_content">
                            <ul>
                                <li>Name: <span>{{ profile  }}</span></li>
                                <li>Email: <span>{{ profile.user.email }}</span></li>
                                <li>Country: <span>{{ profile.country }}</span></li>
                            </ul>

                            <a class="btn w-100 btn-light" href="{% url 'accounts:profile_edit' %}">Edit Profile</a>
                        </div>

                </div>
            </div>
        </div>
    </div>

{% endblock body %}

accounts/templates/accounts/profile_edit.html
{{% extends "accounts_base.html" %}
{% load bootstrap5 %}
{% block body %}



    <!-------------- HERO SECTION --------------->
    <div class="bradcam_area bradcam_bg_1">
        <div class="container">
{#            <div class="row">#}
{#                <div class="col-xl-12">#}
{#                    <div class="bradcam_text">#}
{#                        <h3></h3>#}
{#                    </div>#}
{#                </div>#}
{#            </div>#}
        </div>
    </div>
    <!-------------- HERO SECTION --------------->


    <!-------------- CONTENT SECTION --------------->
    <div class="job_details_area">
        <div class="container">
            <div class="row">
                <div class="col-lg-10 mx-auto">
                    <div class="apply_job_form white-bg">
                        <h4>Edit Profile Information</h4>
                        <form method = 'POST' enctype="multipart/form-data">
                            <div>
                                {% csrf_token %}
                                {% bootstrap_form userform %}
                                {% bootstrap_form profileform %}
                                <button class="boxed-btn3 w-100 mt-2" value="login" type="submit">Sign Up</button>
                            </div>
                        </form>
                    </div>
                </div>

            </div>
        </div>
    </div>


    <!-------------- CONTENT SECTION --------------->

{% endblock body %}